' @copyright(disclaimer) 
' Licensed Materials - Property of IBM
' IBM  Enterprise Information Portal for Multiplatforms V8.1  (program number 5724-B43)
' (c ) Copyright IBM Corp. 1998,  2002. All Rights Reserved.
' 
' US Government Users Restricted Rights
' Use, duplication or disclosure restricted by GSA ADP Schedule
' Contract with IBM Corp.
' 
' DISCLAIMER OF WARRANTIES :
' 
' Permission is granted to copy and modify this Sample code, and to
' distribute modified versions provided that both the copyright
' notice,- and this permission notice and warranty disclaimer appear in all copies and 
' modified versions. 
' 
' THIS SAMPLE CODE IS LICENSED TO YOU AS-IS. 
' IBM AND ITS SUPPLIERS AND LICENSORS DISCLAIM ALL WARRANTIES, EITHER EXPRESS OR IMPLIED, 
' IN SUCH SAMPLE CODE, INCLUDING THE WARRANTY OF NON-INFRINGEMENT AND THE IMPLIED 
' WARRANTIES OF MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. IN NO EVENT WILL 
' IBM OR ITS LICENSORS OR SUPPLIERS BE LIABLE FOR ANY DAMAGES ARISING OUT OF THE USE OF OR 
' INABILITY TO USE THE SAMPLE CODE, DISTRIBUTION OF THE SAMPLE CODE, OR COMBINATION OF THE 
' SAMPLE CODE WITH ANY OTHER CODE. IN NO EVENT SHALL IBM OR ITS LICENSORS AND 
' SUPPLIERS BE LIABLE FOR ANY LOST REVENUE, LOST PROFITS OR DATA, OR FOR DIRECT, INDIRECT, 
' SPECIAL, CONSEQUENTIAL,INCIDENTAL OR PUNITIVE DAMAGES, HOWEVER CAUSED AND REGARDLESS OF 
' THE THEORY OF LIABILITY,-, EVEN IF IBM OR ITS LICENSORS OR SUPPLIERS HAVE BEEN ADVISED 
' OF THE POSSIBILITY OF SUCH DAMAGES.
'
' @endCopyright

VERSION 5.00
Begin VB.Form TXdoCRUDV4 
   Caption         =   "TXdoCRUDV4"
   ClientHeight    =   8895
   ClientLeft      =   135
   ClientTop       =   360
   ClientWidth     =   6465
   LinkTopic       =   "TXdoCRUDV4"
   ScaleHeight     =   8895
   ScaleWidth      =   6465
   StartUpPosition =   3  'Windows Default
   Begin VB.CommandButton Connect 
      Caption         =   "Connect"
      Height          =   495
      Left            =   240
      TabIndex        =   1
      Top             =   7800
      Width           =   1455
   End
   Begin VB.CommandButton Update 
      Caption         =   "Update"
      Height          =   495
      Left            =   3480
      TabIndex        =   6
      Top             =   8400
      Width           =   1335
   End
   Begin VB.CommandButton Delete 
      Caption         =   "Delete"
      Height          =   495
      Left            =   5040
      TabIndex        =   5
      Top             =   8400
      Width           =   1215
   End
   Begin VB.CommandButton Retrieve 
      Caption         =   "Retrieve"
      Height          =   495
      Left            =   1920
      TabIndex        =   4
      Top             =   8400
      Width           =   1215
   End
   Begin VB.CommandButton Add 
      Caption         =   "Add"
      Height          =   495
      Left            =   240
      TabIndex        =   3
      Top             =   8400
      Width           =   1452
   End
   Begin VB.CommandButton Disconnect 
      Caption         =   "Disconnect"
      Height          =   495
      Left            =   1920
      TabIndex        =   2
      Top             =   7800
      Width           =   1215
   End
   Begin VB.TextBox Results 
      Height          =   7455
      Left            =   240
      MultiLine       =   -1  'True
      ScrollBars      =   3  'Both
      TabIndex        =   0
      Top             =   240
      Width           =   6015
   End
End
Attribute VB_Name = "TXdoCRUDV4"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False

Dim dsV4 As DXDatastoreV4
Dim xdo As DXBlobV4
Dim pid As DXPidXDOV4
Dim itemId As String
Dim fileName1 As String
Dim fileName2 As String
Dim partId As Integer
Dim repType As String

' Sample program for XDO create/retrieve/update/delete

Private Sub cout(str As String)
    Results.Text = Results.Text & Chr$(13) & Chr$(10) & str
End Sub

Private Sub Connect_Click()
    On Error GoTo Errors
    Results.Text = ""
    cout "The following itemId and partId will be used:"
    cout "(Please change the itemId to an existing one of your system, "
    cout " and change the partId to the one you pick, "
    cout " or use 0 to let system to generate one for your newly added object) "
    cout " "

'    itemId = "DA99300AA.AAB"    ' TEST index class
    itemId = "DA99103AA.AAM"    ' DATATYPE index class
    partId = 25
    repType = "        "    ' must be "        " (8 blanks)
    Set dsV4 = New DXDatastoreV4
    Set xdo = New DXBlobV4
    xdo.init dsV4    ' must call init first before calling other methods
    xdo.setPartId partId
    xdo.setItemId itemId
    xdo.setRepType repType

    cout "  itemId = " & itemId
    cout "  partId = " & partId
    cout "  repType = " & repType
    cout " "
    cout "The following files will be used for add() & update(): "
    cout "(please change to existing file names with fullpath)"
    cout " "

    fileName1 = "c:\\p\\cmvc\\dk\\samples\\activex\\v4\\test_add.txt"
    fileName2 = "c:\\p\\cmvc\\dk\\samples\\activex\\v4\\test_update.txt"
    cout " file for add()    = " & fileName1
    cout " file for update() = " & fileName2
    cout " "
    cout "Connecting to VI400 datastore..."
    dsV4.Connect "stealth3", "a03admin", "a03admin", ""
    cout "=== Datastore " & xdo.datastore.datastoreName & " connected ==="

    Disconnect.Enabled = True
    Connect.Enabled = False
    Add.Enabled = True
    Retrieve.Enabled = True
    Delete.Enabled = True
    Update.Enabled = True

    Exit Sub

Errors:
    cout "Errors:" & str(Err.Number) & Err.Description

End Sub

Private Sub Disconnect_Click()
  On Error GoTo Errors
  Results.Text = ""
  cout "disconnecting from VI400 datastore..."
  dsV4.Disconnect
  cout "=== datastore disconnected ==="
  Connect.Enabled = True
  Disconnect.Enabled = False
  Add.Enabled = False
  Retrieve.Enabled = False
  Delete.Enabled = False
  Update.Enabled = False

  Exit Sub

Errors:
  cout "Errors:" & str(Err.Number) & Err.Description

End Sub

' add XDO

Private Sub Add_Click()
    On Error GoTo Errors

    Results.Text = ""
    cout "itemId = " & xdo.getItemId
    cout "partId = " & xdo.getPartId
    cout "repType = " & xdo.getRepType
    cout "fileName for add() = " & fileName1

    xdo.setContentClass DX_V4_CC_ASCII   ' must be text file
    xdo.setContentFromClientFile fileName1

    cout "about to call add()..."
    xdo.Add
    cout "add successfully..."
    cout "partId for the newly added part = " & xdo.getPartId

    Exit Sub

Errors:
    cout "Errors:" & str(Err.Number) & Err.Description

End Sub

' retrieve XDO

Private Sub Retrieve_Click()
    On Error GoTo Errors

    Results.Text = ""
    cout "itemId = " & xdo.getItemId
    cout "partId = " & xdo.getPartId

    cout "=== about to call retrieve() ==="  ' retrieve(fileName) is not supported
    xdo.Retrieve

    cout "  retrieve successfully"
    cout "=== about to call open() ==="
    cout " +++ Note: open for ASCII file only +++ "

    If xdo.getContentClass() = DX_V4_CC_ASCII Then
       xdo.setInstanceOpenHandler "notepad ", True
       xdo.open
    End If

    Exit Sub

Errors:
    cout "Errors:" & str(Err.Number) & Err.Description

End Sub

' delete XDO

Private Sub Delete_Click()
    On Error GoTo Errors
    Results.Text = ""
    cout "itemId = " & xdo.getItemId
    cout "partId = " & xdo.getPartId

    cout "=== about to call del() ==="
    xdo.del
    cout "  delete successfully"

    Exit Sub

Errors:
    cout "Errors:" & str(Err.Number) & Err.Description

End Sub

' update XDO

Private Sub Update_Click()
    On Error GoTo Errors
    Results.Text = ""
    cout "itemId = " & xdo.getItemId
    cout "partId = " & xdo.getPartId
    cout "fileName for update = " & fileName2

    xdo.setContentFromClientFile fileName2

    cout "about to call update()..."
    xdo.Update
    cout "update successfully..."
    Exit Sub

Errors:
    cout "Errors:" & str(Err.Number) & Err.Description

End Sub
