/************************************************************************/
/*BEGINPROLOGUE************************************************************************
 * @copyright(disclaimer)                                                             *
 * Licensed Materials - Property of IBM                                               *
 * IBM Enterprise Information Portal for Multiplatforms V8.1 (program number 5724-B43)*
 * (c ) Copyright IBM Corp. 1998,  2002. All Rights Reserved.                         *
 *                                                                                    *
 * US Government Users Restricted Rights                                              *
 * Use, duplication or disclosure restricted by GSA ADP Schedule                      *
 * Contract with IBM Corp.                                                            *
 *                                                                                    *
 * DISCLAIMER OF WARRANTIES :                                                         *
 *                                                                                    *
 * Permission is granted to copy and modify this Sample code, and to                  *
 * distribute modified versions provided that both the copyright                      *
 * notice,- and this permission notice and warranty disclaimer appear in all copies   * 
 * and modified versions.                                                             *
 *                                                                                    *
 * THIS SAMPLE CODE IS LICENSED TO YOU AS-IS.                                         *
 * IBM AND ITS SUPPLIERS AND LICENSORS DISCLAIM ALL WARRANTIES, EITHER EXPRESS OR     *
 * IMPLIED, IN SUCH SAMPLE CODE, INCLUDING THE WARRANTY OF NON-INFRINGEMENT AND THE   *
 * IMPLIED WARRANTIES OF MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. IN NO   *
 * EVENT WILL IBM OR ITS LICENSORS OR SUPPLIERS BE LIABLE FOR ANY DAMAGES ARISING OUT *
 * OF THE USE OF OR INABILITY TO USE THE SAMPLE CODE, DISTRIBUTION OF THE SAMPLE CODE,*
 * OR COMBINATION OF THE SAMPLE CODE WITH ANY OTHER CODE. IN NO EVENT SHALL IBM OR ITS*
 * LICENSORS AND SUPPLIERS BE LIABLE FOR ANY LOST REVENUE, LOST PROFITS OR DATA, OR   *
 * FOR DIRECT, INDIRECT, SPECIAL, CONSEQUENTIAL,INCIDENTAL OR PUNITIVE DAMAGES,       *
 * HOWEVER CAUSED AND REGARDLESS OF THE THEORY OF LIABILITY,-, EVEN IF IBM OR ITS     *
 * LICENSORS OR SUPPLIERS HAVE BEEN ADVISED OF THE POSSIBILITY OF SUCH DAMAGES.       *
 *                                                                                    *
 * @endCopyright                                                                      *
 **************************************************************************************/
/************************************************************************/

// sample connect/execute/disconnect to DB2
/*
 * Filename       : TExecuteDB2.cpp
 * Description    : Connect to DB2 Datastore.
 *                  Create query string.
 *                  Specify to retrieve folder and documents.
 *                  Specify to retrieve a max result of 5 items.
 *                  Get the result in a resultset cursor.
 *                  Loop thru results.
 *                  Display documents found and their parts and attributes,
 *                   if folders found display them and their documents/
 *                   folders.
 *                  Disconnect from DB2 Datastore.
 */

#include <iostream.h>
#include <stdio.h>                
#include <DKConstantDB2.h>
#include <DKDatastoreDB2.hpp>
#include <DKException.hpp>
#include <DKString.hpp>
#include <dkResultSetCursor.hpp>
#include <DKDDO.hpp>
#include <DKAny.hpp>
#include <DKPid.hpp>
#include <dkCollection.hpp>
#include <dkXDO.hpp>
#include <DKEnvironment.hpp>

void main(int argc, char *argv[])
{
    cout << "begin..." << endl;

    // Indicate this is a Console Application on Windows NT/95 for error
    // message code page conversion to OEM code page. If this was a Windows
    // GUI (Graphic User Interface) Application this would not be necessary
    // because DK_SS_WINDOWS is the default.
    DKEnvironment::setSubSystem(DK_SS_CONSOLE);

    //-------------------------------------------------------------- 
    // Checking for input parameters
    //--------------------------------------------------------------   
    if (argc < 4)
    {
     cout<<"Usage: "<<endl;
     cout<<"  TExecuteDB2 <database> <userid> <pw>" << endl;
     return;
    }
    // ### get input parameters
    DKString database = DKString(argv[1]);
    DKString userid = DKString(argv[2]);
    DKString pw = DKString(argv[3]);
    try {
    DKDatastoreDB2 dsDB2;
    dkResultSetCursor* pCur = 0;
    DKNVPair par[2];
    DKAny anyValue;
    DKString strMax = "5";
    anyValue = strMax;
    par[0].set(DK_CM_PARM_MAX_RESULTS, anyValue);
    par[1].setName(DK_CM_PARM_END);
    cout << "Datastore DB2 created" << endl;
    cout << "connecting to datastore" << endl;
    dsDB2.connect(database,userid,pw);
    cout << "datastore connected " << database << " userid - " << userid << endl;
    DKString cmd = "SELECT * FROM EMPLOYEE";
    cout << "query string " << cmd << endl;
    cout << "executing query" << endl;
    pCur = dsDB2.execute(cmd,DK_CM_SQL_QL_TYPE,par);
    cout << "query executed" << endl;
    cout << "cardinality " << pCur->cardinality() << endl;
    DKDDO *p = 0;
    dkDataObjectBase *pDOBase = 0;
    DKDDO *pDDO = 0;
    dkXDO *pXDO = 0;
    DKAny a;
    ushort j = 0;
    ushort k = 0;
    ushort val = 0;
    ushort cnt = 1;
    DKString strData = "";
    DKString strDataName = "";
    dkCollection* pdCol = 0;
    dkIterator*  pdIter = 0;
    ushort numDataItems = 0;
    DKString strPid;
    DKPid* pid = 0;
    short sVal = 0;
    long lVal = 0;
    while (pCur->isValid())
    {
     p = pCur->fetchNext();
     if (p != 0)
     {
      cout << "==========> " << "Item " << cnt << " <=========" << endl;
      numDataItems = p->dataCount();
      pid = (DKPid*)p->getPidObject();
      strPid = pid->pidString();
      cout << "pid string " << strPid << endl;
      k = p->propertyId(DK_CM_PROPERTY_ITEM_TYPE);
      if (k > 0)
      {
       a = p->getProperty(k);
       val = a;
       cout << "******************************" << endl;
       switch (val)
       {
        case DK_CM_ITEM :
        {
  	 cout << "Item found " << endl;
         break;
	}
       }
       cout << "******************************" << endl;
      }
      cout << "Number of Data Items " << numDataItems << endl;
      for (j = 1; j <= numDataItems; j++)
      {
       a = p->getData(j);
       strDataName = p->getDataName(j);
       switch (a.typeCode())
       {
        case DKAny::tc_string :
	{
         strData = a;
         cout << "attribute name : " << strDataName << " value : " << strData << endl;
         break;
	}
        case DKAny::tc_short :
	{
         sVal = a;
         cout << "attribute name : " << strDataName << " value : " << sVal << endl;
         break;
	}
        case DKAny::tc_long :
	{
         lVal = a;
         cout << "attribute name : " << strDataName << " value : " << lVal << endl;
         break;
	}
        case DKAny::tc_date :
	{
         DKDate date = a;
         char* pFormat = 0;
         strData = date.asString(pFormat);
         cout << "attribute name : " << strDataName << " value : " << strData << endl;
         break;
	}
        case DKAny::tc_time :
	{
         DKTime time = a;
         char* pFormat = 0;
         strData = time.asString(pFormat);
         cout << "attribute name : " << strDataName << " value : " << strData << endl;
         break;
	}
        case DKAny::tc_timestamp :
	{
         DKTimestamp tstamp = a;
         char* pFormat = 0;
         strData = tstamp.asString(pFormat);
         cout << "attribute name : " << strDataName << " value : " << strData << endl;
         break;
	}
        case DKAny::tc_dobase :
	{
         dkXDO* pXDO = 0;
         DKDDO* pDDO = 0;
         pDOBase = a;
         if (pDOBase->protocol() == DK_XDO)
	 {
          strData = "XDO found ";
          pXDO = (dkXDO*)pDOBase;
	  pid = (DKPid*)pXDO->getPidObject();
	  strPid = pid->pidString();
	  cout << "pid string " << strPid << endl;
	 }
         cout << "attribute name : " << strDataName << " value : " << strData << endl;
         break;
	}
       }
      }
      cnt++;
      delete p;
     }
    }
     cout << "Total Item count is " << cnt-1 << endl;
     if (pCur != 0)
       delete pCur;
     dsDB2.disconnect();
     cout << "datastore disconnected" << endl;
    }
    catch(DKException &exc)
    {

      cout << "Error id " << exc.errorId() << endl;
      cout << "Exception id " << exc.exceptionId() << endl;
      for(unsigned long i = 0; i< exc.textCount();i++)
      {
       cout << "Error text: " << exc.text(i) << endl;
      }
      for (unsigned long g=0; g< exc.locationCount();g++)
      {
       const DKExceptionLocation* p = exc.locationAtIndex(g);
       cout << "Filename: " << p->fileName() << endl;
       cout << "Function: " << p->functionName() << endl;
       cout << "LineNumber: " << p->lineNumber() << endl;
      }
      cout << "Exception Class Name: " << exc.name() << endl;
    }
    cout << "done ..." << endl;

}

