/*BEGINPROLOGUE************************************************************************
 * @copyright(disclaimer)                                                             *
 * Licensed Materials - Property of IBM                                               *
 * IBM Enterprise Information Portal for Multiplatforms V8.1 (program number 5724-B43)*
 * (c ) Copyright IBM Corp. 1998,  2002. All Rights Reserved.                         *
 *                                                                                    *
 * US Government Users Restricted Rights                                              *
 * Use, duplication or disclosure restricted by GSA ADP Schedule                      *
 * Contract with IBM Corp.                                                            *
 *                                                                                    *
 * DISCLAIMER OF WARRANTIES :                                                         *
 *                                                                                    *
 * Permission is granted to copy and modify this Sample code, and to                  *
 * distribute modified versions provided that both the copyright                      *
 * notice,- and this permission notice and warranty disclaimer appear in all copies   * 
 * and modified versions.                                                             *
 *                                                                                    *
 * THIS SAMPLE CODE IS LICENSED TO YOU AS-IS.                                         *
 * IBM AND ITS SUPPLIERS AND LICENSORS DISCLAIM ALL WARRANTIES, EITHER EXPRESS OR     *
 * IMPLIED, IN SUCH SAMPLE CODE, INCLUDING THE WARRANTY OF NON-INFRINGEMENT AND THE   *
 * IMPLIED WARRANTIES OF MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. IN NO   *
 * EVENT WILL IBM OR ITS LICENSORS OR SUPPLIERS BE LIABLE FOR ANY DAMAGES ARISING OUT *
 * OF THE USE OF OR INABILITY TO USE THE SAMPLE CODE, DISTRIBUTION OF THE SAMPLE CODE,*
 * OR COMBINATION OF THE SAMPLE CODE WITH ANY OTHER CODE. IN NO EVENT SHALL IBM OR ITS*
 * LICENSORS AND SUPPLIERS BE LIABLE FOR ANY LOST REVENUE, LOST PROFITS OR DATA, OR   *
 * FOR DIRECT, INDIRECT, SPECIAL, CONSEQUENTIAL,INCIDENTAL OR PUNITIVE DAMAGES,       *
 * HOWEVER CAUSED AND REGARDLESS OF THE THEORY OF LIABILITY,-, EVEN IF IBM OR ITS     *
 * LICENSORS OR SUPPLIERS HAVE BEEN ADVISED OF THE POSSIBILITY OF SUCH DAMAGES.       *
 *                                                                                    *
 * @endCopyright                                                                      *
 **************************************************************************************/
                         
//*****************************************************************************
//
// Filename : TLISTWORKBASKETWFS.CPP/MAK
// Description : list workbasket in WorkFlow/WorkBasket
//
//*****************************************************************************

#include <iostream.h>
#include <stdio.h>                
#include <DKConstant.h>
#include <DKDatastoreDL.hpp>
#include <DKWorkFlowServiceDL.hpp>
#include <DKException.hpp> 
#include <DKString.hpp>
#include <DKDDO.hpp>
#include <DKSequentialCollection.hpp>
#include <DKEnvironment.hpp>

void main(int argc, char *argv[])
{
    //replace following with your library server name, userid, pasword
    DKString STR_LIB_SERVER = "LIBSRVRN";
    DKString STR_USER_ID    = "FRNADMIN";
    DKString STR_PASSWORD   = "PASSWORD";

    cout << "begin..." << endl;
    DKDatastoreDL dsDL; // must be outside try/catch block

    try {
    // Indicate this is a Console Application on Windows NT/95 for error
    // message code page conversion to OEM code page. If this was a Windows
    // GUI (Graphic User Interface) Application this would not be necessary
    // because DK_SS_WINDOWS is the default.
    DKEnvironment::setSubSystem(DK_SS_CONSOLE);

    DKWorkFlowServiceDL wfDL(&dsDL);

    cout << "Datastore DL created" << endl;
    cout << "connecting to datastore" << endl;
    dsDL.connect(STR_LIB_SERVER, STR_USER_ID, STR_PASSWORD);
    cout << "datastore connected" << endl;
  
    DKSequentialCollection * wbList1 = (DKSequentialCollection *)wfDL.listWorkBaskets();
    if (wbList1 != NULL)
      {
	dkIterator * pIter1 = wbList1->createIterator();
        DKWorkBasketDL * pwb1;
	cout << "There are " << wbList1->cardinality() << " workbasket(s) defined in the system." << endl;
        while (pIter1->more())
          {
            pwb1 = (DKWorkBasketDL *)((void*)(*pIter1->next())); 
            cout << "Workbasket ID = " << pwb1->getID() << endl;
            pwb1->retrieve();
            cout << "Workbasket Name = " << pwb1->getName() << endl;
            delete pwb1;
          }
      }
 
    DKSequentialCollection * wbList2 = (DKSequentialCollection *)wfDL.listWorkBasketIDs();
    if (wbList2 != NULL)
      {
        dkIterator* pIter2 = wbList2->createIterator(); 
        DKString wb2;
	cout << "There are " << wbList2->cardinality() << " workbasket(s) defined in the system." << endl;
        while(pIter2->more() == TRUE)
          {
	    wb2 = (DKString)(*pIter2->next());
	    cout << "Workbasket ID = " << wb2 << endl;		
          }
      }

    dsDL.disconnect();
    cout << "datastore disconnected" << endl;
    }
 
    catch(DKException &exc)
    {
      cout << "Error id "     << exc.errorId() << endl;
      cout << "Exception id " << exc.exceptionId() << endl;
      for(unsigned long i = 0; i< exc.textCount();i++)
      {
       cout << "Error text: " << exc.text(i) << endl;
      }
      for (unsigned long g=0; g< exc.locationCount();g++)
      {
       const DKExceptionLocation* p = exc.locationAtIndex(g);
       cout << "Filename: " << p->fileName() << endl;
       cout << "Function: " << p->functionName() << endl;
       cout << "LineNumber: " << p->lineNumber() << endl;
      }
      cout << "Exception Class Name: " << exc.name() << endl;
    }

    cout << "done ..." << endl;
    
}
