/*BEGINPROLOGUE************************************************************************
 * @copyright(disclaimer)                                                             *
 * Licensed Materials - Property of IBM                                               *
 * IBM Enterprise Information Portal for Multiplatforms V8.1 (program number 5724-B43)*
 * (c ) Copyright IBM Corp. 1998,  2002. All Rights Reserved.                         *
 *                                                                                    *
 * US Government Users Restricted Rights                                              *
 * Use, duplication or disclosure restricted by GSA ADP Schedule                      *
 * Contract with IBM Corp.                                                            *
 *                                                                                    *
 * DISCLAIMER OF WARRANTIES :                                                         *
 *                                                                                    *
 * Permission is granted to copy and modify this Sample code, and to                  *
 * distribute modified versions provided that both the copyright                      *
 * notice,- and this permission notice and warranty disclaimer appear in all copies   * 
 * and modified versions.                                                             *
 *                                                                                    *
 * THIS SAMPLE CODE IS LICENSED TO YOU AS-IS.                                         *
 * IBM AND ITS SUPPLIERS AND LICENSORS DISCLAIM ALL WARRANTIES, EITHER EXPRESS OR     *
 * IMPLIED, IN SUCH SAMPLE CODE, INCLUDING THE WARRANTY OF NON-INFRINGEMENT AND THE   *
 * IMPLIED WARRANTIES OF MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. IN NO   *
 * EVENT WILL IBM OR ITS LICENSORS OR SUPPLIERS BE LIABLE FOR ANY DAMAGES ARISING OUT *
 * OF THE USE OF OR INABILITY TO USE THE SAMPLE CODE, DISTRIBUTION OF THE SAMPLE CODE,*
 * OR COMBINATION OF THE SAMPLE CODE WITH ANY OTHER CODE. IN NO EVENT SHALL IBM OR ITS*
 * LICENSORS AND SUPPLIERS BE LIABLE FOR ANY LOST REVENUE, LOST PROFITS OR DATA, OR   *
 * FOR DIRECT, INDIRECT, SPECIAL, CONSEQUENTIAL,INCIDENTAL OR PUNITIVE DAMAGES,       *
 * HOWEVER CAUSED AND REGARDLESS OF THE THEORY OF LIABILITY,-, EVEN IF IBM OR ITS     *
 * LICENSORS OR SUPPLIERS HAVE BEEN ADVISED OF THE POSSIBILITY OF SUCH DAMAGES.       *
 *                                                                                    *
 * @endCopyright                                                                      *
 **************************************************************************************/
//*****************************************************************************
// txdoAddVSDL.cpp - Test DKBlobDL for adding the media object
// (this test case requires you to know the existing itemId and partId first)
// invoke: txdoAddVSDL <fileName to be added> <itemId> <partId>
// you can also code the itemId, partId and fileName in this program and
// just invoke as:  txdoAddVSDL
//*****************************************************************************

#include <iostream.h>
#include <stdio.h>  
#include <stdlib.h>
#include <DKString.hpp>
#include <DKConstantDL.h>
#include <DKDatastoreDL.hpp>
#include <DKMediaStreamInfoDL.hpp>
#include <DKException.hpp>
#include <DKBlobDL.hpp>
#include <DKEnvironment.hpp>

void main(int argc, char *argv[])
{    
    //replace following with your library server name, userid, pasword
    DKString STR_LIB_SERVER = "LIBSRVRN";
    DKString STR_USER_ID    = "FRNADMIN";
    DKString STR_PASSWORD   = "PASSWORD";

   // Indicate this is a Console Application on Windows NT/95 for error
   // message code page conversion to OEM code page. If this was a Windows
   // GUI (Graphic User Interface) Application this would not be necessary
   // because DK_SS_WINDOWS is the default.
   DKEnvironment::setSubSystem(DK_SS_CONSOLE);

    DKString itemId, fileName;
    int partId;
    itemId = "TYV8LHPRNBHJVP8X";
    partId = 22; 
    fileName = "/icing1.mpg1"; 
    
    cout <<"argc is "<<argc<<endl;
    if (argc == 1)
    {
      cout<<"invoke: txdoAddVSDL <fileName> <partId> <itemId>"<<endl;
      cout<<" no parameter, following default will be provided:"<<endl;
      cout<<"The supplied default fileName = "<<fileName<<endl;
      cout<<"The supplied default partId = "<<partId<<endl;
      cout<<"The supplied default itemId = "<<itemId<<endl;
    }
    else if (argc == 2)
    {
     fileName = DKString(argv[1]);
     cout<<"you enter: txdoAddVSDL "<<argv[1]<<endl;
     cout<<"The supplied default partId = "<<partId<<endl;
     cout<<"The supplied default itemId = "<<itemId<<endl;
    }
    else if (argc == 3)
    {
     fileName = DKString(argv[1]);
     partId = atoi(argv[2]);
     cout<<"you enter: txdoAddVSDL "<<argv[1]<<" "<<argv[2]<<endl;
     cout<<"The supplied default itemId = "<<itemId<<endl;
    }
    else if (argc ==  4)
    {
     fileName = DKString(argv[1]);
     partId = atoi(argv[2]);
     itemId = DKString(argv[3]);
     cout<<"you enter: txdoAddVSDL "<<argv[1]<<" "<<argv[2]<< " "<<argv[3]<<endl;
    }

    DKDatastoreDL dsDL;  // must be outside try/catch block

    try 
    {
      // *** connect to datastore
      cout << "Connecting datastore ..." << endl;
      dsDL.connect(STR_LIB_SERVER, STR_USER_ID, STR_PASSWORD);
      cout << "Datastore connected" << endl;
      
      // *** create xdo and pid  
      DKBlobDL* axdo = new DKBlobDL(&dsDL);
      DKPidXDODL*  apid = new DKPidXDODL;
      apid ->setPartId(partId);
      apid ->setPrimaryId(itemId);
      axdo ->setPidObject(apid);
      axdo ->setContentClass(DK_DL_CC_IBMVSS);
      cout <<"itemId= " << axdo->getItemId()<<endl;
      cout <<"partId="<< axdo->getPartId()<<endl;
      cout <<"repType="<< axdo->getRepType()<<endl;  
      cout <<"contentclass="<< axdo->getContentClass()<<endl;

      // *** setup DKMediaStreamInfoDL
      DKMediaStreamInfoDL aVS;
      aVS.setMediaFullFileName(fileName);
      //if fileName contain a list of media segments then use following
      //aVS.setMediaObjectOption(DK_DL_VS_LIST_OF_OBJECT_SEGMENTS);
      aVS.setMediaObjectOption(DK_DL_VS_SINGLE_OBJECT);
      aVS.setMediaHostName("vcharger1.stl.ibm.com"); 
      aVS.setMediaUserId("root");     
      aVS.setMediaPassword("video2");
      aVS.setMediaNumberOfUsers(1);
      aVS.setMediaAssetGroup("AG");  //must same as Video Charger defined
      aVS.setMediaType("MPEG1");
      aVS.setMediaResolution("SIF");
      aVS.setMediaStandard("NTSC");
      aVS.setMediaFormat("SYSTEM");   
      axdo ->setExtension("DKMediaStreamInfoDL", (dkExtension*)&aVS);
      cout <<"about to do add()"<<endl;
      axdo ->add();        
      cout<<"Object added successfully "<<endl;

      cout<<"after added check for status:"<<endl;
      DKBoolean flag2 = axdo->isCategoryOf(DK_DL_MEDIA_OBJECT);
      if (flag2)
      {
        DKMediaStreamInfoDL* mediaInfo = (DKMediaStreamInfoDL*)axdo->getExtension("DKMediaStreamInfoDL");
        cout<<"  copyRate="<<mediaInfo->getMediaCopyRate()<<endl;
        cout<<"  mediaType="<<mediaInfo->getMediaType()<<endl;
        cout<<"  mediaFramRates="<<mediaInfo->getMediaFrameRate()<<endl;
        cout<<"  mediaState="<<mediaInfo->getMediaState()<<endl; 
        cout<<"  mediaTimestamp="<<mediaInfo->getMediaTimestamp()<<endl; 
        cout<<"  MediaState(dynamic)="<<axdo->retrieveObjectState(DK_MEDIA_OBJECT)<<endl;	
      }

      dsDL.disconnect();
      cout<<"datastore disconnected"<<endl;
    }
    catch(DKException &exc)
    {
      cout << "Error id " << exc.errorId() << endl;
      cout << "Exception id " << exc.exceptionId() << endl;
      for(unsigned long i = 0; i< exc.textCount();i++)
      {
       cout << "Error text: " << exc.text(i) << endl;
      }
      for (unsigned long g=0; g< exc.locationCount();g++)
      {
       const DKExceptionLocation* p = exc.locationAtIndex(g);
       cout << "Filename: " << p->fileName() << endl;
       cout << "Function: " << p->functionName() << endl;
       cout << "LineNumber: " << p->lineNumber() << endl;
      }
      cout << "Exception Class Name: " << exc.name() << endl;
    }
    cout << "done ..." << endl;    
}

