#########################################################################################
# @copyright(disclaimer)                                                                #
# Licensed Materials - Property of IBM                                                  #
# IBM  Enterprise Information Portal for Multiplatforms V8.1  (program number 5724-B43) #
# (c ) Copyright IBM Corp. 1998,  2002. All Rights Reserved.                            #
#                                                                                       #
# US Government Users Restricted Rights                                                 #
# Use, duplication or disclosure restricted by GSA ADP Schedule                         #
# Contract with IBM Corp.                                                               #
#                                                                                       #
# DISCLAIMER OF WARRANTIES :                                                            #
#                                                                                       #
# Permission is granted to copy and modify this Sample code, and to                     #
# distribute modified versions provided that both the copyright                         #
# notice,- and this permission notice and warranty disclaimer appear                    #
# in all copies and modified versions.                                                  #
#                                                                                       #
# THIS SAMPLE CODE IS LICENSED TO YOU AS-IS.                                            #
# IBM AND ITS SUPPLIERS AND LICENSORS DISCLAIM ALL WARRANTIES, EITHER EXPRESS OR        #
# IMPLIED, IN SUCH SAMPLE CODE, INCLUDING THE WARRANTY OF NON-INFRINGEMENT AND THE      #
# IMPLIED WARRANTIES OF MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. IN NO      #
# EVENT WILL IBM OR ITS LICENSORS OR SUPPLIERS BE LIABLE FOR ANY DAMAGES ARISING OUT OF #
# THE USE OF OR INABILITY TO USE THE SAMPLE CODE, DISTRIBUTION OF THE SAMPLE CODE, OR   #
# COMBINATION OF THE SAMPLE CODE WITH ANY OTHER CODE. IN NO EVENT SHALL IBM OR ITS      #
# LICENSORS AND SUPPLIERS BE LIABLE FOR ANY LOST REVENUE, LOST PROFITS OR DATA, OR FOR  #
# DIRECT, INDIRECT, SPECIAL, CONSEQUENTIAL,INCIDENTAL OR PUNITIVE DAMAGES, HOWEVER      #
# CAUSED AND REGARDLESS OF THE THEORY OF LIABILITY,-, EVEN IF IBM OR ITS LICENSORS OR   #
# SUPPLIERS HAVE BEEN ADVISED OF THE POSSIBILITY OF SUCH DAMAGES.                       #
#                                                                                       #
# @endCopyright                                                                         #
#########################################################################################
#* ----------------------------------------------------------- *#
#* Name           : TADLstFed                                  *#
#* Description    : make file                                  *#
#* ----------------------------------------------------------- *#

!IF "$(DEBUG)" == ""
DEBUG=0
!ENDIF 

# content connect root directory
!IF "$(CMBROOT)" == ""
CMBROOT=C:\CMBROOT
!ENDIF

# Microsoft VC++ root directory MSVCDir
!IF "$(MSVCDIR)" == ""
MSVCDIR=C:\PROGRA~1\MICROS~1\VC98
!ENDIF 

# Microsoft VC++ root directory 
!IF "$(MSDEV)" == ""
MSDEV=$(MSVCDIR)
!ENDIF

!IF "$(DKCMBPATH)" == ""
DKCMBPATH=$(CMBROOT)
!ENDIF

!IF "$(DKCMBLIBPATH)" == ""
DKCMBLIBPATH=$(DKCMBPATH)\lib
!ENDIF

!IF "$(DKCMBINCLUDEPATH)" == ""
DKCMBINCLUDEPATH=$(DKCMBPATH)\include
!ENDIF 

!IF "$(MSDEVLIBPATH)" == ""
MSDEVLIBPATH=$(MSDEV)\lib
!ENDIF

# determine location of MFC (based on version of VC++)
!IF "$(DKCPPVER)" == "6"
DKMFCDIR=MFC
!ELSEIF "$(DKCPPVER)" == "7"
DKMFCDIR=ATLMFC
!ELSE
DKMFCDIR=
!ENDIF

!IF "$(DKCMVER)" == ""
DKCMVER=81
!ENDIF 

!IF "$(MSDEVMFCLIBPATH)" == ""
MSDEVMFCLIBPATH=$(MSDEV)\$(DKMFCDIR)\lib
MSDEVPLATLIBPATH=$(MSDEV)\PlatformSDK\lib
!ENDIF

DKINCLUDE=/I$(DKCMBINCLUDEPATH) /I"$(MSDEV)"\include /I"$(MSDEV)"\$(DKMFCDIR)\include
DKDEFINES=/D "WIN32" /D "_AFXDLL" /D "_MBCS" /D "_CONSOLE" 

!IF  "$(DEBUG)" == "0"
OUTDIR=.\bin
INTDIR=.\obj

DKDLLIB= $(DKCMBLIBPATH)\cmbcm$(DKCMVER)$(DKCPPVER).lib $(DKCMBLIBPATH)\cmbfed$(DKCMVER)$(DKCPPVER).lib 

DKRFLAGS = /d "NDEBUG" 
DKCFLAGS =  /c /nologo /MD /W3 /O2 /GR /GX /D "NDEBUG" $(DKDEFINES) \
            /Fo"$(INTDIR)\\" /Fp"$(INTDIR)\TADLstFed.pch" /YX /Fd"$(INTDIR)\\" /FD 

DKMPORTAL_CC = $(DKCFLAGS) $(DKINCLUDE) $(DKDLINC)
DKMPORTAL_C = $(DKCFLAGS) $(DKINCLUDE) $(DKDLINC)
DKLINKFLGS =/nologo /subsystem:console  /incremental:no \
 /pdb:"$(OUTDIR)\TADLstFed.pdb" /machine:I386 \
 /out:"$(OUTDIR)\TADLstFed.exe"

!ELSE 
OUTDIR=.\db_bin
INTDIR=.\db_obj

DKDLLIB= $(DKCMBLIBPATH)\cmbcm$(DKCMVER)$(DKCPPVER)d.lib $(DKCMBLIBPATH)\cmbfed$(DKCMVER)$(DKCPPVER)d.lib 

DKRFLAGS = /d "_DEBUG"
DKCFLAGS = /c /nologo /MDd /W3 /Od /GR /GM /Zi /GX /D "_DEBUG" $(DKDEFINES) \
           /Fd"$(INTDIR)\\" /Fo"$(INTDIR)\\" /Fp"$(INTDIR)\TADLstFed.pch" /YX /FR"$(INTDIR)\\" 

DKMPORTAL_CC = $(DKCFLAGS) $(DKINCLUDE) $(DKDLINC)
DKMPORTAL_C =  $(DKCFLAGS) $(DKINCLUDE) $(DKDLINC)
DKLINKFLGS =/nologo /subsystem:console  /incremental:yes \
 /pdb:"$(OUTDIR)\TADLstFed.pdb" /DEBUG /machine:I386 \
 /out:"$(OUTDIR)\TADLstFed.exe"

!ENDIF 

.cpp{$(INTDIR)}.obj:
   cl $(DKMPORTAL_CC) $<  

DKEXE = "$(OUTDIR)\TADLstFed.exe"
DKOBJS = "$(INTDIR)\TADLstFed.obj"

all: "$(OUTDIR)" "$(INTDIR)" $(DKOBJS) $(DKEXE)

"$(OUTDIR)" :
    if not exist "$(OUTDIR)" mkdir "$(OUTDIR)"

"$(INTDIR)" :
    if not exist "$(INTDIR)" mkdir "$(INTDIR)"

"$(INTDIR)\TADLstFed.obj": .\TADLstFed.cpp

"$(OUTDIR)\TADLstFed.exe": $(DKOBJS)
	link $(DKDLLIB) $(DKLINKFLGS) /LIBPATH:$(DKCMBLIBPATH) /LIBPATH:$(MSDEVLIBPATH) /LIBPATH:$(MSDEVMFCLIBPATH) /LIBPATH:"$(MSDEVPLATLIBPATH)" $(DKOBJS)


