/*BEGINPROLOGUE************************************************************************
 * @copyright(disclaimer)                                                             *
 * Licensed Materials - Property of IBM                                               *
 * IBM Enterprise Information Portal for Multiplatforms V8.1 (program number 5724-B43)*
 * (c ) Copyright IBM Corp. 1998,  2002. All Rights Reserved.                         *
 *                                                                                    *
 * US Government Users Restricted Rights                                              *
 * Use, duplication or disclosure restricted by GSA ADP Schedule                      *
 * Contract with IBM Corp.                                                            *
 *                                                                                    *
 * DISCLAIMER OF WARRANTIES :                                                         *
 *                                                                                    *
 * Permission is granted to copy and modify this Sample code, and to                  *
 * distribute modified versions provided that both the copyright                      *
 * notice,- and this permission notice and warranty disclaimer appear in all copies   * 
 * and modified versions.                                                             *
 *                                                                                    *
 * THIS SAMPLE CODE IS LICENSED TO YOU AS-IS.                                         *
 * IBM AND ITS SUPPLIERS AND LICENSORS DISCLAIM ALL WARRANTIES, EITHER EXPRESS OR     *
 * IMPLIED, IN SUCH SAMPLE CODE, INCLUDING THE WARRANTY OF NON-INFRINGEMENT AND THE   *
 * IMPLIED WARRANTIES OF MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. IN NO   *
 * EVENT WILL IBM OR ITS LICENSORS OR SUPPLIERS BE LIABLE FOR ANY DAMAGES ARISING OUT *
 * OF THE USE OF OR INABILITY TO USE THE SAMPLE CODE, DISTRIBUTION OF THE SAMPLE CODE,*
 * OR COMBINATION OF THE SAMPLE CODE WITH ANY OTHER CODE. IN NO EVENT SHALL IBM OR ITS*
 * LICENSORS AND SUPPLIERS BE LIABLE FOR ANY LOST REVENUE, LOST PROFITS OR DATA, OR   *
 * FOR DIRECT, INDIRECT, SPECIAL, CONSEQUENTIAL,INCIDENTAL OR PUNITIVE DAMAGES,       *
 * HOWEVER CAUSED AND REGARDLESS OF THE THEORY OF LIABILITY,-, EVEN IF IBM OR ITS     *
 * LICENSORS OR SUPPLIERS HAVE BEEN ADVISED OF THE POSSIBILITY OF SUCH DAMAGES.       *
 *                                                                                    *
 * @endCopyright                                                                      *
 **************************************************************************************/
// sample
/*
 * Filename       : TCheckedOutInV4.cpp
 * Description    : test isCheckedOur, CheckedOutDSUserid, and unlockCheckedOutDS
 *
 */

#include <iostream.h>
#include <stdio.h>                
#include <DKConstant.h>
#include <DKDatastoreV4.hpp>
#include <DKDatastoreExtV4.hpp>
#include <DKException.hpp>
#include <DKString.hpp>
#include <DKEnvironment.hpp>
#include "DKDDO.hpp"
#include "DKPid.hpp"

void main(int argc, char *argv[])
{
   cout << "begin..." << endl;
   // Indicate this is a Console Application on Windows NT/95 for error
   // message code page conversion to OEM code page. If this was a Windows
   // GUI (Graphic User Interface) Application this would not be necessary
   // because DK_SS_WINDOWS is the default.
   DKEnvironment::setSubSystem(DK_SS_CONSOLE);
    DKString indexClass = "NOINDEX";
    DKString itemId = "DB02213AA.AAK";

    //-------------------------------------------------------------- 
    // Checking for input parameters
    //--------------------------------------------------------------   
    if (argc < 4)
    {
     cout<<"Usage: "<<endl;
     cout<<"  TCheckedOutInV4 <libsrv> <userid> <pw> <indexClass> <itemId>" << endl;
     return;
    }
    // ### get input parameters
    DKString libsrv = DKString(argv[1]);
    DKString userid = DKString(argv[2]);
    DKString pw = DKString(argv[3]);
    if (argc == 4)
    {
      cout<<"no parameter for indexClass, itemId, following default will be provided:"<<endl;
      cout<<"   default indexClass = "<<indexClass<<endl;
      cout<<"   default itemId = "<<itemId<<endl;
    }
    else if (argc == 5)
    {
     indexClass = DKString(argv[4]);
     cout<<" indexClass entered: "<<argv[4]<<endl;
     cout<<" The supplied default itemId = "<<itemId<<endl;
    }
    else if (argc == 6)
    {
     indexClass = DKString(argv[4]);
     itemId = DKString(argv[5]);
     cout<<" indexClass/itemId entered: "<<argv[4]<<" "<<argv[5]<<endl;
    }



   try {
      DKDatastoreV4 dsV4;
/*
      DKAny input_option = DK_SS_CONFIG;
      DKAny output_option;
      dsV4.setOption(DK_OPT_V4_ACCESS, input_option);
      dsV4.getOption(DK_OPT_V4_ACCESS, output_option);
*/
      cout << "Datastore V4 created" << endl;
      cout << "connecting to datastore" << endl;
      dsV4.connect(libsrv,userid,pw);
      cout << "datastore connected " << libsrv << " userid - " << userid << endl;

      DKString DDOid;
      DKAny a;
      DKDDO* p = 0;
      DKString cUID;
      DKPid pid;   
      short k = 0;
      pid.setObjectType(indexClass);
      pid.setPrimaryId(itemId );

      //** checkout
      p = new DKDDO(&dsV4, pid);
         
      DKDatastoreExtV4* ext = new DKDatastoreExtV4(&dsV4);
      cout << "starting test " << endl;
      
      cout << "about to check out itemId="<< itemId <<" from indexClass="<<indexClass<<endl;
      ext->checkOut(p);
      cout << "after checking out show check out status:"<<endl;
      DKBoolean fRet = dsV4.isCheckedOut(p);
      if (fRet == TRUE)
	  cout << "  itemid is checkout " << endl;
      else
	  cout << "  itemid is not checkout " << endl;
      k = p->propertyId(DK_CM_PROPERTY_CHECKOUT);
      if (k > 0)
      {
       a = p->getProperty(k);
       cUID = a;
       cout << "  expected checkout userid=" << cUID << endl;
      }

      dsV4.checkedOutUserid(p);
      k = p->propertyId(DK_CM_PROPERTY_CHECKOUT);
      if (k > 0)
      {
       a = p->getProperty(k);
       cUID = a;
       cout << "  actual checkout userid=" << cUID << endl;
      }

      //** checkin
      cout << "about to check in itemId="<< itemId <<" to indexClass="<<indexClass<<endl;
      dsV4.checkIn(p);
      DKBoolean fRet2 = dsV4.isCheckedOut(p);
      cout << "after checking in show check out status:"<<endl;
      if (fRet2 == TRUE)
	  cout << "  itemid is checkout " << endl;
      else
	  cout << "  itemid is not checkout " << endl;

      dsV4.disconnect();
      cout << "datastore disconnected" << endl;
   }
   catch(DKException &exc)
   {
      cout << "Error id " << exc.errorId() << endl;
      for(unsigned long i = 0; i< exc.textCount();i++)
      {
         cout << "Error text: " << exc.text(i) << endl;
      }
      for (unsigned long g=0; g< exc.locationCount();g++)
      {
         const DKExceptionLocation* p = exc.locationAtIndex(g);
         cout << "Filename: " << p->fileName() << endl;
         cout << "Function: " << p->functionName() << endl;
         cout << "LineNumber: " << p->lineNumber() << endl;
      }

      cout << "Exception Class Name: " << exc.name() << endl;
   }
   
   cout << "done ..." << endl;   
}

