/*
@copyright(disclaimer)

Licensed Materials - Property of IBM
IBM  Enterprise Information Portal  for Multiplatforms V8.1  (program number 5724-B43)
(c) Copyright IBM Corp. 1998,  2002. All Rights Reserved.

US Government Users Restricted Rights
Use, duplication or disclosure restricted by GSA ADP Schedule
Contract with IBM Corp.

DISCLAIMER OF WARRANTIES :

Permission is granted to copy and modify this  Sample code, and to
distribute modified versions provided that both the copyright
notice,- and this permission notice and warranty disclaimer  appear in all copies and modified
versions.

THIS SAMPLE CODE IS LICENSED TO YOU AS-IS.
IBM  AND ITS SUPPLIERS AND LICENSORS  DISCLAIM
ALL WARRANTIES, EITHER EXPRESS OR IMPLIED, IN SUCH SAMPLE CODE, INCLUDING THE WARRANTY
OF NON-INFRINGEMENT AND THE IMPLIED WARRANTIES OF MERCHANTABILITY OR FITNESS FOR A
PARTICULAR PURPOSE. IN NO EVENT WILL IBM OR ITS LICENSORS OR SUPPLIERS BE LIABLE FOR ANY
DAMAGES ARISING OUT OF THE USE OF  OR INABILITY TO USE THE SAMPLE CODE, DISTRIBUTION OF
THE SAMPLE CODE, OR COMBINATION OF THE SAMPLE CODE WITH ANY OTHER CODE. IN NO EVENT SHALL
IBM OR ITS LICENSORS AND SUPPLIERS BE LIABLE FOR ANY LOST REVENUE, LOST PROFITS OR DATA,
OR FOR DIRECT, INDIRECT, SPECIAL, CONSEQUENTIAL,INCIDENTAL OR PUNITIVE DAMAGES, HOWEVER
CAUSED AND REGARDLESS OF THE THEORY OF LIABILITY,-, EVEN IF IBM OR ITS LICENSORS OR SUPPLIERS
HAVE BEEN ADVISED OF THE POSSIBILITY OF SUCH DAMAGES.

@endCopyright
*/

//*****************************************************************************
// Class Name  = UtilTableModel
// Description =
// Author      = mimivo
// Date        = 04/22/99
//*****************************************************************************

import com.ibm.mm.beans.*;

import java.util.*;
import javax.swing.*;
import javax.swing.table.*;
import javax.swing.event.TableModelListener;
import javax.swing.event.TableModelEvent;

public class UtilTableModel extends DefaultTableModel {
    private static final String ibmid = "5648-D03 and 5648-D04 " + "(C) Copyright IBM Corp. 1994,1999";

    JTable table;
    //dkResultSetCursor pCur        = null;
    int rowCount = 0;
    Vector resultData = new Vector();
    Vector itemList = new Vector();
    Vector dispList; // element type: Choice
    int dispCount = 0;

    public UtilTableModel(Vector dispList) {
        this.dispList = dispList;
        dispCount = dispList.size();
        //addTableModelListener(this);
        for (int i = 0; i < dispCount; i++) {
            System.out.println("DisplayName = " + (String) dispList.elementAt(i));
        }
    }

    public int getColumnCount() {
        //System.out.println("dispCount = "+dispCount);
        return dispCount;
    }
    public String getColumnName(int column) {
        return (String) dispList.elementAt(column);
    }
    //public Class getColumnClass(int c) {return getValueAt(0, c).getClass();}
    public Class getColumnClass(int c) {
        return String.class;
    }
    public boolean isCellEditable(int row, int col) {
        return getColumnClass(col) == String.class;
    }
    public int getRowCount() {
        return rowCount;
    }

    public void setValueAt(Object aValue, int row, int column) {
        String[] rowData = (String[]) resultData.elementAt(row);
        rowData[column] = (String) aValue;
        resultData.setElementAt((Object) rowData, row);
    }

    public Object getValueAt(int row, int col) {
        return (Object) ((String[]) resultData.elementAt(row))[col];
    }

    public Object getValueAt(Object colID, int rowIdx) {
        for (int i = 0; i < dispCount; ++i) { // check the colID against
            // the display attr names
            if (((String) dispList.elementAt(i)).equals(colID))
                return (Object) ((String[]) resultData.elementAt(rowIdx))[i];
        }
        return "null";
    }

    public void tableRowsInserted(TableModelEvent evt) {
        //table.resizeAndRepaint();
    }

    public void tableChanged(TableModelEvent evt) {
    }

    public void tableRowsRemoved(TableModelEvent evt) {
        //table.resizeAndRepaint();
    }

    public void setTable(JTable table) {
        this.table = table;
    }

    public void resetData() {
        rowCount = 0;
        resultData = new Vector();
        itemList = new Vector();
    }

    public void loadData(CMBHitItem[] itemArray) {
        short attrCnt = 0;
        String attrName;
        short i, j;

        String[] dataRow = null;
        String attribute;

        try {
            for (i = 0; i < itemArray.length; i++) {
                CMBHitItem item = itemArray[i];
                String[] values = item.getAttrValue();
                attrCnt = (short) values.length;
                dataRow = new String[dispCount];
                System.arraycopy(values, 0, dataRow, 0, dispCount);
                for (j = attrCnt; j < dispCount; j++)
                    dataRow[j] = "";
                resultData.addElement(dataRow);
                rowCount++;
                itemList.addElement(item);
                table.tableChanged(new TableModelEvent(this));
            }
        } catch (Exception exc) {
            exc.printStackTrace();
        }
    }

    public String getItemID(int idx) throws Exception {
        return (String) ((CMBItem) itemList.elementAt(idx)).getPidString();
    }

    public CMBItem getItemObject(int idx) throws ArrayIndexOutOfBoundsException {
        return (CMBItem) itemList.elementAt(idx);
    }
}