/*BEGINPROLOGUE************************************************************************
 * @copyright(disclaimer)                                                             *
 * Licensed Materials - Property of IBM                                               *
 * IBM Enterprise Information Portal for Multiplatforms V8.1 (program number 5724-B43)*
 * (c ) Copyright IBM Corp. 1998,  2002. All Rights Reserved.                         *
 *                                                                                    *
 * US Government Users Restricted Rights                                              *
 * Use, duplication or disclosure restricted by GSA ADP Schedule                      *
 * Contract with IBM Corp.                                                            *
 *                                                                                    *
 * DISCLAIMER OF WARRANTIES :                                                         *
 *                                                                                    *
 * Permission is granted to copy and modify this Sample code, and to                  *
 * distribute modified versions provided that both the copyright                      *
 * notice,- and this permission notice and warranty disclaimer appear in all copies   * 
 * and modified versions.                                                             *
 *                                                                                    *
 * THIS SAMPLE CODE IS LICENSED TO YOU AS-IS.                                         *
 * IBM AND ITS SUPPLIERS AND LICENSORS DISCLAIM ALL WARRANTIES, EITHER EXPRESS OR     *
 * IMPLIED, IN SUCH SAMPLE CODE, INCLUDING THE WARRANTY OF NON-INFRINGEMENT AND THE   *
 * IMPLIED WARRANTIES OF MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. IN NO   *
 * EVENT WILL IBM OR ITS LICENSORS OR SUPPLIERS BE LIABLE FOR ANY DAMAGES ARISING OUT *
 * OF THE USE OF OR INABILITY TO USE THE SAMPLE CODE, DISTRIBUTION OF THE SAMPLE CODE,*
 * OR COMBINATION OF THE SAMPLE CODE WITH ANY OTHER CODE. IN NO EVENT SHALL IBM OR ITS*
 * LICENSORS AND SUPPLIERS BE LIABLE FOR ANY LOST REVENUE, LOST PROFITS OR DATA, OR   *
 * FOR DIRECT, INDIRECT, SPECIAL, CONSEQUENTIAL,INCIDENTAL OR PUNITIVE DAMAGES,       *
 * HOWEVER CAUSED AND REGARDLESS OF THE THEORY OF LIABILITY,-, EVEN IF IBM OR ITS     *
 * LICENSORS OR SUPPLIERS HAVE BEEN ADVISED OF THE POSSIBILITY OF SUCH DAMAGES.       *
 *                                                                                    *
 * @endCopyright                                                                      *
 **************************************************************************************/

/*
 * Filename       : TGetDocModelTS.java
 * Description    : Get a document model for TS
 *
 */

import com.ibm.mm.sdk.common.*;
import com.ibm.mm.sdk.server.*;
import java.io.*;

// TGetDocModelTS class
public class TGetDocModelTS implements DKConstantDL {

  // Main method
  public static void main(String argv[]){
    
    // Indicate this is a Console Application on Windows NT/95 for error
    // message display in dos console code page. If this was a Windows
    // GUI (Graphic User Interface) Application this would not be necessary
    // because DK_CM_SS_WINDOWS is the default.
    DKEnvironment.setSubSystem(DK_CM_SS_CONSOLE);

    //-------------------------------------------------------------- 
    // Checking for input parameters
    //-------------------------------------------------------------- 
    if (argv.length < 2){
        System.out.println("Invoke Syntax: " );
        System.out.println("  java TGetDocModelTS <srchSrv> <docModelName>" );
        return;
    }
   
    String srchSrv      = argv[0];
    String docModelName = argv[1];
       
    DKDatastoreTS dsTS = null;
    try {
        DKSequentialCollection pCol = null;
        DKDatastoreDefTS dsDef = null;
        DKDatastoreAdminTS dsAdmin = null;
        dkIterator pIter = null;
        DKDocModelTS pDocModel = null;
        DKDocSectionTS pDocSection = null;
        int numSections = 0;
        int ccsid = DK_TS_CCSID_00850;
        String strDocModelName = null;
        String strSectionName = null;
        String strSectionTag = null;
        int i = 0;
        int j = 0;
        Integer iOpt = null;
        dsTS = new DKDatastoreTS();
        
        System.out.println("connecting to datastore"); 
        dsTS.connect(srchSrv,"",' ');
        System.out.println("datastore connected"); 
        
        System.out.println("get a doc model");
        dsDef = (DKDatastoreDefTS)dsTS.datastoreDef();
        dsAdmin = (DKDatastoreAdminTS)dsDef.datastoreAdmin();
        pDocModel = dsAdmin.getDocModel("",ccsid,docModelName);
        strDocModelName = pDocModel.getName();
        ccsid = pDocModel.getCCSID();
        System.out.println("got doc model - " + strDocModelName + " CCSID - " + ccsid);
        numSections = pDocModel.numberOfDocSections();
        for (j = 1; j <= numSections; j++){
             pDocSection = pDocModel.getDocSection(j);
             strSectionName = pDocSection.getName();
             strSectionTag = pDocSection.getTag();
             System.out.println("Doc section [" + j + "] - " + strSectionName + " sectionTag - " + strSectionTag);
        }
        System.out.println(" done getting doc model");
    
        dsTS.disconnect();
        System.out.println("datastore disconnected"); 
        dsTS.destroy();
    }
    catch (DKException exc){
     	try {
     	    dsTS.destroy();
     	}
     	catch (Exception e)
     	{
     	 e.printStackTrace();
     	}        
        System.out.println("Exception name " + exc.name());
        System.out.println("Exception message " + exc.getMessage());
        exc.printStackTrace();
    }
    catch (Exception exc){
     	try {
     	    dsTS.destroy();
     	}
     	catch (Exception e)
     	{
     	 e.printStackTrace();
     	}        
        System.out.println("Exception message " + exc.getMessage());
        exc.printStackTrace();
    }
  }
}

