/*BEGINPROLOGUE************************************************************************
 * @copyright(disclaimer)                                                             *
 * Licensed Materials - Property of IBM                                               *
 * IBM Enterprise Information Portal for Multiplatforms V8.1 (program number 5724-B43)*
 * (c ) Copyright IBM Corp. 1998,  2002. All Rights Reserved.                         *
 *                                                                                    *
 * US Government Users Restricted Rights                                              *
 * Use, duplication or disclosure restricted by GSA ADP Schedule                      *
 * Contract with IBM Corp.                                                            *
 *                                                                                    *
 * DISCLAIMER OF WARRANTIES :                                                         *
 *                                                                                    *
 * Permission is granted to copy and modify this Sample code, and to                  *
 * distribute modified versions provided that both the copyright                      *
 * notice,- and this permission notice and warranty disclaimer appear in all copies   * 
 * and modified versions.                                                             *
 *                                                                                    *
 * THIS SAMPLE CODE IS LICENSED TO YOU AS-IS.                                         *
 * IBM AND ITS SUPPLIERS AND LICENSORS DISCLAIM ALL WARRANTIES, EITHER EXPRESS OR     *
 * IMPLIED, IN SUCH SAMPLE CODE, INCLUDING THE WARRANTY OF NON-INFRINGEMENT AND THE   *
 * IMPLIED WARRANTIES OF MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. IN NO   *
 * EVENT WILL IBM OR ITS LICENSORS OR SUPPLIERS BE LIABLE FOR ANY DAMAGES ARISING OUT *
 * OF THE USE OF OR INABILITY TO USE THE SAMPLE CODE, DISTRIBUTION OF THE SAMPLE CODE,*
 * OR COMBINATION OF THE SAMPLE CODE WITH ANY OTHER CODE. IN NO EVENT SHALL IBM OR ITS*
 * LICENSORS AND SUPPLIERS BE LIABLE FOR ANY LOST REVENUE, LOST PROFITS OR DATA, OR   *
 * FOR DIRECT, INDIRECT, SPECIAL, CONSEQUENTIAL,INCIDENTAL OR PUNITIVE DAMAGES,       *
 * HOWEVER CAUSED AND REGARDLESS OF THE THEORY OF LIABILITY,-, EVEN IF IBM OR ITS     *
 * LICENSORS OR SUPPLIERS HAVE BEEN ADVISED OF THE POSSIBILITY OF SUCH DAMAGES.       *
 *                                                                                    *
 * @endCopyright                                                                      *
 **************************************************************************************/

/* -------------------------------------------------------------------------
 * Name        : TMemUsage.c
 * Description : gets VirtualMemory size for the current process on NT.
 *               
 *               This program can be used independently (through DLL from 
 *               C or through java/JNI from TMemUsage.java)
 *
 *               This program needs two Microsoft files psapi.h psapi.lib
 *               these ProcessStatusAPI files can be downloaded from 
 *               Microsoft web site (from msdn.microsoft.com search for 
 *               psapi).
 *
 * Author      : Chandra S Potula
 * Create Date : 10/15/2000
 * 
 * Change History
 * -------------------------------------------------------------------------
 */

#include <jni.h>
#include <stdio.h>

#ifdef WIN32
#include <windows.h>
#include "psapi.h"
#pragma comment(lib,"Psapi.lib")
#endif

#include "TMemUsage.h"

// Right now this method is for NT only.  Need to write equilent code on AIX
JNIEXPORT long getVMSize() {
	long                    lVMSize = -1;

#ifdef WIN32
	int                     lPID    = GetCurrentProcessId();
	HANDLE                  lHandle = 0;
	PROCESS_MEMORY_COUNTERS lPMC;

	lHandle = OpenProcess(PROCESS_QUERY_INFORMATION | PROCESS_VM_READ, FALSE, lPID);
	if(GetProcessMemoryInfo(lHandle, &lPMC, sizeof(lPMC))) {
		lVMSize = lPMC.PagefileUsage; 
	}

	CloseHandle(lHandle);
#endif

	return lVMSize;
}
JNIEXPORT jlong JNICALL Java_TMemUsage_getVMSize(
		JNIEnv *env, jobject jobj) {
	return getVMSize();
}
