/* -------------------------------------------------------------------
 * @copyright(disclaimer) 
 * IBM Enterprise Information Portal for Multiplatforms V7.1  (program number 5697-G29) 
 * (c ) Copyright IBM Corp. 1998, 2000. All Rights Reserved. 
 * IBM Content Manager for Multiplatforms V6.1  (program number 5648-D03) 
 * (c ) Copyright IBM Corp. 1994, 2000. All Rights Reserved. 
 * 
 * US Government Users Restricted Rights 
 * Use, duplication or disclosure restricted by GSA ADP Schedule 
 * Contract with IBM Corp.  Licensed Materials - Property of IBM 
 * 
 * DISCLAIMER OF WARRANTIES : 
 * 
 * Permission is granted to copy and modify this code, and to 
 * distribute modified versions provided that both the copyright 
 * notice and this permission notice appear in all copies and modified 
 * versions. THIS SAMPLE CODE IS LICENSED TO YOU AS-IS. IBM DISCLAIMS 
 * ALL WARRANTIES, EITHER EXPRESS OR IMPLIED, IN SUCH SAMPLE CODE. IBM 
 * WILL NOT BE LIABLE FOR ANY DAMAGES WHATSOEVER RESULTING FROM THE USE 
 * OF THE CODE.
 * 
 * @endCopyright
 */

/*
 * Filename       : TAttrsIC.java
 * Description    : sample for attr functions
 * Change History :
 *
 * Date        Name  Description     
 * -------    -----  ---------------------------
 *
 */

import com.ibm.mm.sdk.common.*;
import com.ibm.mm.sdk.server.*;
import java.io.*;

// TAttrsIC class
public class TAttrsIC implements DKConstantIC {

  // Main method
  public static void main(String argv[]){
    
      String db = new String("");   // database
      String userid = new String("");   // userid
      String pw = new String("");   // pw
      String schema = new String("");   // schema
      int i = 0;
      int count = 0;

   // Indicate this is a Console Application on Windows NT/95 for error
   // message display in dos console code page. If this was a Windows
   // GUI (Graphic User Interface) Application this would not be necessary
   // because DK_CM_SS_WINDOWS is the default.
   DKEnvironment.setSubSystem(DK_CM_SS_CONSOLE);

      //-------------------------------------------------------------- 
      // Checking for input parameters
      //-------------------------------------------------------------- 
      if (argv.length < 3)
      {
       System.out.println("Usage: " );
       System.out.println("  java TAttrsIC " +
        "<db> <userid> <pw>" );
       return;
      }

      db = argv[0];
      userid = argv[1];
      pw = argv[2];

    try {

       DKDatastoreIC dsIC = new DKDatastoreIC();
       dsIC.connect(db, userid, pw, "");
       System.out.println("--- connected to datastore ---");


// listAttrs()

      dkEntityDef entity = dsIC.datastoreDef().getEntity("Glossary entries");
      dkIterator itr = entity.listAttrs().createIterator();
      count = 0;
      while ( itr.more() ) {
         count ++;
         dkAttrDef attr = (dkAttrDef)itr.next();
         System.out.println("Attr = " + attr.getName());
      }
      System.out.println("Number of attrs = " + count);

// listAttrNames()

      dkEntityDef entity2 = dsIC.datastoreDef().getEntity("Relational tables and views");
      String attrNames[] = entity2.listAttrNames();
      int numAttrs = attrNames.length;
      count = 0;
      for ( i = 0; i < numAttrs; i++) {
          count ++;
          System.out.println("Attr Name = " + attrNames[i]);
      }

      System.out.println("Number of attr names = " + count);


// getAttr()

      dkEntityDef entity3 = dsIC.datastoreDef().getEntity("Glossary entries");
      dkAttrDef attrDef = entity3.getAttr("Keywords");
      String attrName = attrDef.getName();
      System.out.println("Attr = " + attrName);

       dsIC.disconnect();
       System.out.println("datastore disconnected");
       dsIC.destroy();
    }
    catch(DKException exc)
    {
       System.out.println("Exception name " + exc.name());
       System.out.println("Exception message " + exc.getMessage());
       System.out.println("Exception error code " + exc.errorCode());
       System.out.println("Exception error state " + exc.errorState());
       exc.printStackTrace();
    }
    catch (Exception exc)
    {
     System.out.println("Exception message " + exc.getMessage());
     exc.printStackTrace();
    }
  }
}

