/* -------------------------------------------------------------------
 * @copyright(disclaimer) 
 * IBM Enterprise Information Portal for Multiplatforms V7.1  (program number 5697-G29) 
 * (c ) Copyright IBM Corp. 1998, 2000. All Rights Reserved. 
 * IBM Content Manager for Multiplatforms V6.1  (program number 5648-D03) 
 * (c ) Copyright IBM Corp. 1994, 2000. All Rights Reserved. 
 * 
 * US Government Users Restricted Rights 
 * Use, duplication or disclosure restricted by GSA ADP Schedule 
 * Contract with IBM Corp.  Licensed Materials - Property of IBM 
 * 
 * DISCLAIMER OF WARRANTIES : 
 * 
 * Permission is granted to copy and modify this code, and to 
 * distribute modified versions provided that both the copyright 
 * notice and this permission notice appear in all copies and modified 
 * versions. THIS SAMPLE CODE IS LICENSED TO YOU AS-IS. IBM DISCLAIMS 
 * ALL WARRANTIES, EITHER EXPRESS OR IMPLIED, IN SUCH SAMPLE CODE. IBM 
 * WILL NOT BE LIABLE FOR ANY DAMAGES WHATSOEVER RESULTING FROM THE USE 
 * OF THE CODE.
 * 
 * @endCopyright
 */

// test list servers from IC

/*
 * Filename       : TListDataSourcesIC.java
 * Description    : test DKDatastoreIC for list functions
 * Change History :
 *
 * Date        Name  Description     
 * -------    -----  ---------------------------
 */

import com.ibm.mm.sdk.common.*;
import com.ibm.mm.sdk.server.*;
import java.io.*;

// TListDataSourcesIC class
public class TListDataSourcesIC implements DKConstantIC {

  // Main method
  public static void main(String argv[]){
    
      String libSrv = new String("");   // libserver
      String userid = new String("");   // userid
      String pw = new String("");   // pw

   // Indicate this is a Console Application on Windows NT/95 for error
   // message display in dos console code page. If this was a Windows
   // GUI (Graphic User Interface) Application this would not be necessary
   // because DK_CM_SS_WINDOWS is the default.
   DKEnvironment.setSubSystem(DK_CM_SS_CONSOLE);

    try {

       dkCollection pCol = null;
       dkIterator pIter = null;
       DKServerDefIC pSV = null;
       DKEntityDefIC eDef = null;
       String strServerName = null;
       String strEntityName = null;
       int i = 0;
       int j = 0;
       DKDatastoreIC dsIC = new DKDatastoreIC();

       pCol = dsIC.listDataSources();
       pIter = pCol.createIterator();
       while (pIter.more() == true)
       {
          i++;
          pSV = (DKServerDefIC)pIter.next();
          strServerName = pSV.getName();
          System.out.println("Server Name [" + i + "] - " + strServerName);
       }
       System.out.println(i + " servers listed");

       String[] srvNames = dsIC.listDataSourceNames();
       int numSrvs = srvNames.length;
       for (i = 0; i < numSrvs; i++)
       {
          System.out.println("Server Name [" + (i+1) + "] - " + srvNames[i]);
       }
       System.out.println(i + " servers listed");

           
    }
    catch(DKException exc)
    {
       System.out.println("Exception name " + exc.name());
       System.out.println("Exception message " + exc.getMessage());
       System.out.println("Exception error code " + exc.errorCode());
       System.out.println("Exception error state " + exc.errorState());
       exc.printStackTrace();
    }
    catch (Exception exc)
    {
     System.out.println("Exception message " + exc.getMessage());
     exc.printStackTrace();
    }
  }
}

