/*BEGINPROLOGUE************************************************************************
 * @copyright(disclaimer)                                                             *
 * Licensed Materials - Property of IBM                                               *
 * IBM Enterprise Information Portal for Multiplatforms V8.1 (program number 5724-B43)*
 * (c ) Copyright IBM Corp. 1998,  2002. All Rights Reserved.                         *
 *                                                                                    *
 * US Government Users Restricted Rights                                              *
 * Use, duplication or disclosure restricted by GSA ADP Schedule                      *
 * Contract with IBM Corp.                                                            *
 *                                                                                    *
 * DISCLAIMER OF WARRANTIES :                                                         *
 *                                                                                    *
 * Permission is granted to copy and modify this Sample code, and to                  *
 * distribute modified versions provided that both the copyright                      *
 * notice,- and this permission notice and warranty disclaimer appear in all copies   * 
 * and modified versions.                                                             *
 *                                                                                    *
 * THIS SAMPLE CODE IS LICENSED TO YOU AS-IS.                                         *
 * IBM AND ITS SUPPLIERS AND LICENSORS DISCLAIM ALL WARRANTIES, EITHER EXPRESS OR     *
 * IMPLIED, IN SUCH SAMPLE CODE, INCLUDING THE WARRANTY OF NON-INFRINGEMENT AND THE   *
 * IMPLIED WARRANTIES OF MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. IN NO   *
 * EVENT WILL IBM OR ITS LICENSORS OR SUPPLIERS BE LIABLE FOR ANY DAMAGES ARISING OUT *
 * OF THE USE OF OR INABILITY TO USE THE SAMPLE CODE, DISTRIBUTION OF THE SAMPLE CODE,*
 * OR COMBINATION OF THE SAMPLE CODE WITH ANY OTHER CODE. IN NO EVENT SHALL IBM OR ITS*
 * LICENSORS AND SUPPLIERS BE LIABLE FOR ANY LOST REVENUE, LOST PROFITS OR DATA, OR   *
 * FOR DIRECT, INDIRECT, SPECIAL, CONSEQUENTIAL,INCIDENTAL OR PUNITIVE DAMAGES,       *
 * HOWEVER CAUSED AND REGARDLESS OF THE THEORY OF LIABILITY,-, EVEN IF IBM OR ITS     *
 * LICENSORS OR SUPPLIERS HAVE BEEN ADVISED OF THE POSSIBILITY OF SUCH DAMAGES.       *
 *                                                                                    *
 * @endCopyright                                                                      *
 **************************************************************************************/

/*
 * Filename       : TClientListFolderCriteriaOD.java
 * Description    : test DKDatastoreOD for list functions
 * Change History :
 *
 * Date        Name  Description
 * -------    -----  ---------------------------
 * 2002/04/21  nnc   Creation
 *
 */

import com.ibm.mm.sdk.common.*;
import com.ibm.mm.sdk.client.*;
import java.io.*;

// TClientListFolderCriteriaOD class
public class TClientListFolderCriteriaOD implements DKConstantOD
{

  // Main method
  public static void main(String argv[])
  {

    // Indicate this is a Console Application on Windows NT/95 for error
    // message display in dos console code page. If this was a Windows
    // GUI (Graphic User Interface) Application this would not be necessary
    // because DK_CM_SS_WINDOWS is the default.
    DKEnvironment.setSubSystem(DK_CM_SS_CONSOLE);

    String libSrv = new String("");   // libserver
    String userid = new String("");   // userid
    String pw = new String("");   // pw
    String connect_string = new String("");
    String configuration_string = new String("");

    DKDatastoreOD dsOD = null;

    //--------------------------------------------------------------
    // Checking for input parameters
    //--------------------------------------------------------------
    if (argv.length < 1)
    {
      System.out.println("Invoke Syntax: " );
      System.out.println("  java TClientListFolderCriteriaOD " +
                         "<libsrv> <userid> <pw> " +
                         "<connect string> <configuration string>" );
      return;
    }
    else
    {
      libSrv = argv[0];
      userid = argv[1];
      pw = argv[2];
      if (argv.length > 3)
        connect_string = argv[3];
      if (argv.length > 4)
        configuration_string = argv[4];
    }
    System.out.println("connection string=>" + connect_string + "<=");
    System.out.println("configuration string=>" + configuration_string + "<=");

    try
    {
      if (configuration_string.length() > 0)
      {
        configuration_string += ";ENTITY_TYPE=TEMPLATES";
        dsOD = new DKDatastoreOD(configuration_string);
      }
      else
      {
        dsOD = new DKDatastoreOD("ENTITY_TYPE=TEMPLATES");
      }
      DKSequentialCollection pCol = null;
      dkIterator pIter = null;
      DKSequentialCollection pCol2 = null;
      dkIterator pIter2 = null;
      DKServerDefOD pSV = null;
      String strServerName = null;
      String strServerType = null;
      DKDatastoreDefOD dsDef = null;
      String folderName;
      int i = 0;
      int j = 0;
      System.out.println("list servers");
      pCol = (DKSequentialCollection)dsOD.listDataSources();
      pIter = pCol.createIterator();
      while (pIter.more() == true)
      {
        i++;
        pSV = (DKServerDefOD)pIter.next();
        strServerName = pSV.getName();
        strServerType = pSV.getServerType();
        System.out.println("Server Name [" + i + "] - " + strServerName + " Server Type - " + strServerType);
      }
      System.out.println(i + " servers listed");
      System.out.println("connecting to datastore");
      dsOD.connect(libSrv,userid,pw,connect_string);
      System.out.println("datastore connected libSrv " + libSrv + " userid " +
                         userid );
      System.out.println("list folders");
      dsDef = (DKDatastoreDefOD)dsOD.datastoreDef();
      pCol = (DKSequentialCollection) dsDef.listSearchTemplates();
      pIter = pCol.createIterator();
      i = 0;
      while (pIter.more() == true)
      {
        i++;
        DKFolderOD flddef = (DKFolderOD)pIter.next();
        folderName = (String)flddef.getName();
        System.out.println("\n****folder #" + i + "=>" + folderName + "<=*****");
        pCol2 = (DKSequentialCollection)flddef.listCriteria();
        pIter2 = pCol2.createIterator();
        j = 0;
        while (pIter2.more() == true)
        {
          j++;
          DKSearchCriteria critdef = (DKSearchCriteria)pIter2.next();
          String critName = critdef.getName();
          System.out.println("\n  Criteria #" + j + ": name=>" + critName + "<=");

          // valid operators
          short[] validOperators = critdef.getValidOperators();
          if (validOperators != null)
          {
            for (int k = 0; k < validOperators.length; k++)
            {
              System.out.println("   Valid Operator["+(k+1)+"]="+"'"+Op2Str(validOperators[k])+"'");
            }
          }
          else
          {
            System.out.println("   No valid operators.");
          }
          //default operator
          System.out.println("   Default operator='" + Op2Str(critdef.getDefaultOperator())+"'");

          // default values
          String[] defaultValues = critdef.getDefaultValues();
          if (defaultValues != null)
          {
            for (int k = 0;  k < defaultValues.length; k++)
            {
              System.out.println("   Default Value["+(k+1)+"]=>" + defaultValues[k]+"<=");
            }
          }
          else
          {
            System.out.println("   **No Default Values**");
          }

          // predefined values
          dkCollection predefinedValues = critdef.getPredefinedValues();
          dkIterator pIter3 = predefinedValues.createIterator();
          int k = 0;
          int l = 0;
          while (pIter3.more() == true)
          {
            k++;
            //System.out.println("   Predefined Values set #"+k+":");
            DKPredefinedValues predefValues = (DKPredefinedValues)pIter3.next();
            dkCollection predefValPairs = predefValues.getValuePairs();
            dkIterator pIter4 = predefValPairs.createIterator();
            while (pIter4.more() == true)
            {
              l++;
              DKNVPair vp = (DKNVPair)pIter4.next();
              String name = vp.getName();
              System.out.println("   Predefined Value["+l+"]: =>"+name+"<=");
            }
          }
          if (l==0)
          {
            System.out.println("   **No Predefined Values**");
          }
        }
      }
      System.out.println("\n"+ i + " folders listed");
      dsOD.disconnect();
      System.out.println("datastore disconnected");

      dsOD.destroy(); // Finished with the datstore
    }
    catch (DKException exc)
    {
      System.out.println("Exception name " + exc.name());
      System.out.println("Exception message " + exc.getMessage());
      exc.printStackTrace();
    }
    catch (Exception exc)
    {
      System.out.println("Exception message " + exc.getMessage());
      exc.printStackTrace();
    }
  }

  //***********************************************************************
  //   Op2Str
  //***********************************************************************
  public static String Op2Str(short Op)
  {
    String OpStr = new String("");
    switch (Op)
    {
      case DK_CM_OPCODE_EQ         : OpStr = "EQ"         ; break;
      case DK_CM_OPCODE_NEQ        : OpStr = "NEQ"        ; break;
      case DK_CM_OPCODE_GT         : OpStr = "GT"         ; break;
      case DK_CM_OPCODE_LT         : OpStr = "LT"         ; break;
      case DK_CM_OPCODE_LIKE       : OpStr = "LIKE"       ; break;
      case DK_CM_OPCODE_NOTLIKE    : OpStr = "NOTLIKE"    ; break;
      case DK_CM_OPCODE_BETWEEN    : OpStr = "BETWEEN"    ; break;
      case DK_CM_OPCODE_IN         : OpStr = "IN"         ; break;
      case DK_CM_OPCODE_NOTIN      : OpStr = "NOTIN"      ; break;
      case DK_CM_OPCODE_GEQ        : OpStr = "GEQ"        ; break;
      case DK_CM_OPCODE_LEQ        : OpStr = "LEQ"        ; break;
      case DK_CM_OPCODE_NOTBETWEEN : OpStr = "NOTBETWEEN" ; break;
      case DK_CM_OPCODE_AND        : OpStr = "AND"        ; break;
      case DK_CM_OPCODE_OR         : OpStr = "OR"         ; break;
      case DK_CM_OPCODE_NOT        : OpStr = "NOT"        ; break;
      case DK_CM_OPCODE_UNDEFINED  : OpStr = "UNDEFINED"  ; break;
      default                      : OpStr = "Unknown!!!" ; break;
    }
    return OpStr;
  }
}

